using Windows.Foundation.Metadata;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Input;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.richEditBox.Loaded   += richEditBox_Loaded;
            this.richEditBox.Unloaded += richEditBox_Unloaded;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ġ Ʈ ڽ ε óϱ - richEditBox_Loaded(sender, e)

        /// <summary>
        /// ġ Ʈ ڽ ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void richEditBox_Loaded(object sender, RoutedEventArgs e)
        {
            // UniversalApiContract 7  RichEditBox ⺻ ContextFlyout Ʈ .
            if(ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 7))
            {
                this.richEditBox.SelectionFlyout.Opening += flyout_Opening;
                this.richEditBox.ContextFlyout.Opening   += flyout_Opening;
            }
        }

        #endregion
        #region ġ Ʈ ڽ ε óϱ - richEditBox_Unloaded(sender, e)

        /// <summary>
        /// ġ Ʈ ڽ ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void richEditBox_Unloaded(object sender, RoutedEventArgs e)
        {
            // UniversalApiContract 7  RichEditBox ⺻ ContextFlyout Ʈ .
            if(ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 7))
            {
                this.richEditBox.SelectionFlyout.Opening -= flyout_Opening;
                this.richEditBox.ContextFlyout.Opening   -= flyout_Opening;
            }
        }

        #endregion
        #region ö̾ƿ ½ óϱ - flyout_Opening(sender, e)

        /// <summary>
        /// ö̾ƿ ½ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void flyout_Opening(object sender, object e)
        {
            CommandBarFlyout commandBarFlyout = sender as CommandBarFlyout;

            if(commandBarFlyout != null && commandBarFlyout.Target == this.richEditBox)
            {
                AppBarButton appBarButton = new AppBarButton
                {
                    Command = new StandardUICommand(StandardUICommandKind.Share)
                };
            
                commandBarFlyout.PrimaryCommands.Add(appBarButton);
            }
        }

        #endregion
    }
}